#include <intrins.h>
#include "TP.h"
#include "delay.h"
#include "UserDef.h"
#include "RA8889_51.h"
#include "RA8889_MCU_IF.h"
#include "RA8889_API_51.h"	 

unsigned char   Touch_State=0;


#if CTP	   //  Capacitive touch screen
  
#define CONFIG_FT5X0X_MULTITOUCH    //Define the multi-touch
//Touch Status	 


struct _ts_event
{
    uint    x1;
    uint    y1;
    uint    x2;
    uint    y2;
    uint    x3;
    uint    y3;
    uint    x4;
    uint    y4;
    uint    x5;
    uint    y5;
    uchar     touch_point;
	uchar     Key_Sta;	
};

struct _ts_event ts_event; 

#define WRITE_ADD	0x70  
#define READ_ADD	0x71  



//IIC start
void TOUCH_Start(void)
{ 
	SDA1=1;  
	_nop_();	  
	SCL=1;
	delay_us(2);
	SDA1=0;  
	delay_us(2);
	SCL=0;
	_nop_();
}	  


//IIC stop
void TOUCH_Stop(void)
{
	SDA1=0;
	_nop_();
	SCL=1;
	delay_us(2);
	SDA1=1;
	delay_us(2);
	SCL=0;
	_nop_();;							   	
}


//Wait for an answer signal
uchar TOUCH_Wait_Ack(void)
{	uchar errtime=0;

	SDA1=1;
	delay_us(1);
	SCL=1;
	delay_us(1);
  	while(SDA1)
	{
	    errtime++;
	    if(errtime>250)
		    {
		      TOUCH_Stop();
		      return 1;
		    }
	}
	SCL=0;
	_nop_();

  return 0;
}




//Acknowledge
void TOUCH_Ack(void)
{	SCL=0;
	SDA1=0;
	delay_us(2);
	SCL=1;
	delay_us(2);
	SCL=0;
	_nop_();
}



//NO Acknowledge		    
void TOUCH_NAck(void)
{	SCL=0;
	SDA1=1;
	delay_us(2);
	SCL=1;
	delay_us(2);
	SCL=0;
	_nop_();
}	
	

//IIC send one byte		  
void TOUCH_Send_Byte(uchar Byte)
{	uchar t;  		

    for(t=0;t<8;t++)
    { 	SCL=0;            
	   	SDA1=(bit)(Byte & 0x80) ;
	   	Byte <<=1;
		delay_us(2);
	   	SCL=1;
		delay_us(2);
	   	SCL=0;
		delay_us(2);
    }	
 

} 



//Read one byteack=0Send Acknowledgeack=1NO Acknowledge   
uchar TOUCH_Read_Byte(uchar ack)
{	uchar t,receive=0;

	SCL=0;
	SDA1=1;
	for(t = 0; t < 8; t++)
	{	_nop_();
	 	SCL = 1;
		_nop_();
	 	receive<<=1;
	 	if(SDA1 == 1)
	 	receive=receive|0x01;
		delay_us(2);
	 	SCL=0;
		delay_us(2);
	}

					 
   	if (ack)  TOUCH_NAck();//NO Acknowledge 
   	else       TOUCH_Ack(); //Send Acknowledge   
    
	 return receive;
}


void TOUCH_Wr_Reg(uchar RegIndex,uchar RegValue1)
{
	TOUCH_Start();
	TOUCH_Send_Byte(WRITE_ADD);
	TOUCH_Wait_Ack();	
	TOUCH_Send_Byte(RegIndex);
	TOUCH_Wait_Ack();
	
	TOUCH_Send_Byte(RegValue1);
	TOUCH_Wait_Ack();

	TOUCH_Stop();
	delay_us(100);
}


void TOUCH_RdParFrPCTPFun(uchar *PCTP_Par,uchar ValFlag)
{	uchar k;

	TOUCH_Start();
	TOUCH_Send_Byte(READ_ADD);
	TOUCH_Wait_Ack();	
	for(k=0;k<ValFlag;k++)
	{
		if(k==(ValFlag-1))  *(PCTP_Par+k)=TOUCH_Read_Byte(1);
		else                *(PCTP_Par+k)=TOUCH_Read_Byte(0);
	}		
	TOUCH_Stop();
}

/*
uchar TOUCH_Read_Reg(uchar RegIndex)
{	uchar receive=0;

	TOUCH_Start();
	TOUCH_Send_Byte(WRITE_ADD);
	TOUCH_Wait_Ack();
	TOUCH_Send_Byte(RegIndex);
	TOUCH_Wait_Ack();
	
	TOUCH_Start();
	TOUCH_Send_Byte(READ_ADD);
	TOUCH_Wait_Ack();	
	receive=TOUCH_Read_Byte(1);
	TOUCH_Stop();
 	 
	return receive;
}


void ft5x0x_i2c_txdata(uchar *txdata, uchar length)
{	uchar ret =0;	uint num;

  	TOUCH_Start();
  	TOUCH_Send_Byte(WRITE_ADD);      
  	TOUCH_Wait_Ack();
  	for(num=0;num<length;num++)
  	{
		TOUCH_Send_Byte(txdata[num]); 
    	TOUCH_Wait_Ack();      
  	}                   
  	TOUCH_Stop();
  	delay_ms(2);


}

uchar ft5x0x_i2c_rxdata(uchar *rxdata, uchar length)
{	uchar num;	uchar *rxdatatmp =  rxdata;

  	TOUCH_Start();
  	TOUCH_Send_Byte(READ_ADD);
  	TOUCH_Wait_Ack();            
	for(num=0;num<length;num++)
  	{
		if(num==(length-1))  
		rxdatatmp[num]=TOUCH_Read_Byte(0);   
        else 
    	rxdatatmp[num]=TOUCH_Read_Byte(1);   
  	}

  	TOUCH_Stop();
	
  	return rxdatatmp;
}
 */
uchar ft5x0x_read_data(void)
{	uchar buf[32] = {0}; uchar ret = 0;

	#ifdef CONFIG_FT5X0X_MULTITOUCH
		TOUCH_RdParFrPCTPFun(buf, 31);
	#else
  		TOUCH_RdParFrPCTPFun(buf, 7);
	#endif

  	ts_event.touch_point = buf[2] & 0xf;

  	if (ts_event.touch_point == 0) 
		{
			return 0;
  		}

		#ifdef CONFIG_FT5X0X_MULTITOUCH
					switch (ts_event.touch_point) 
					{
							case 5:
				           			ts_event.x5 = (uint)(buf[0x1b] & 0x0F)<<8 | (uint)buf[0x1c];
				           			ts_event.y5 = (uint)(buf[0x1d] & 0x0F)<<8 | (uint)buf[0x1e];
				
						    case 4:
						           	ts_event.x4 = (uint)(buf[0x15] & 0x0F)<<8 | (uint)buf[0x16];
						           	ts_event.y4 = (uint)(buf[0x17] & 0x0F)<<8 | (uint)buf[0x18];
						
						    case 3:
						           	ts_event.x3 = (uint)(buf[0x0f] & 0x0F)<<8 | (uint)buf[0x10];
						           	ts_event.y3 = (uint)(buf[0x11] & 0x0F)<<8 | (uint)buf[0x12];
						
						    case 2:
						           	ts_event.x2 = (uint)(buf[9] & 0x0F)<<8 | (uint)buf[10];
						           	ts_event.y2 = (uint)(buf[11] & 0x0F)<<8 | (uint)buf[12];
						
						    case 1:
						           	ts_event.x1 = (uint)(buf[3] & 0x0F)<<8 | (uint)buf[4];
						           	ts_event.y1 = (uint)(buf[5] & 0x0F)<<8 | (uint)buf[6];
				
						    break;
						    default:
						    return 0;
					}
		#else

				  	if (ts_event.touch_point == 1)
				  	{
				    	ts_event.x1 = (uint)(buf[3] & 0x0F)<<8 | (uint)buf[4];
				    	ts_event.y1 = (uint)(buf[5] & 0x0F)<<8 | (uint)buf[6];
				    	ret = 1;
				  	}
				  	else
				  	{
						ts_event.x1 = 0xFFFF;
				    	ts_event.y1 = 0xFFFF;
				    	ret = 0;
				  	}
		#endif

    
	return ret;
}


void inttostr(uint value,uchar *str)
{
	str[0]=value/1000+48;
	str[1]=value%1000/100+48;
	str[2]=value%1000%100/10+48;
 	str[3]=value%1000%100%10+48;
}




////////////////////////////////////
void  counter0(void) interrupt 0
{
 	if(INT==0)										//Detect the occurrence of an interrupt
 	{
		ts_event.Key_Sta=Key_Down;                              

 	}
}

void TOUCH_Init(void)
{
	 IT0=1;        //Falling edge trigger  
	 EX0=1;
	 EA=1;
		SDA1=1;
		SCL=1;
		RESET=0;
		delay_ms(10);
		RESET=1;;
		delay_ms(10);
}


void TPTEST(void)
{
	uchar ss[4];  	


	 TOUCH_Init();


	Main_Image_Start_Address(0);				
	Main_Image_Width(LCD_Width);							
	Main_Window_Start_XY(0,0);

	Canvas_Image_Start_address(0);//Layer 1
	Canvas_image_width(LCD_Width);//
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);

 	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width,LCD_Height);
	Start_Square_Fill();

 ///////////////////////////Square
	Foreground_color_65k(Red);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square();
	delay_ms(1);


 	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,0,0);


	while(next)
	{	Foreground_color_65k(White);
		Background_color_65k(Black);

		Goto_Text_XY(40,200);	
		Show_String("Capacitive touch screen test");
		Goto_Text_XY(LCD_Width-61,LCD_Height-25);
		Show_String("Clear");   
		Goto_Text_XY(5,LCD_Height-25);
		Show_String("Exit");

			if(ts_event.Key_Sta==Key_Down)        //The touch screen is pressed
			{
				EX0=0;//Close interrupt
				do
				{
					ft5x0x_read_data();
					ts_event.Key_Sta=Key_Up;
		

  				if ((ts_event.x1<45) &&(ts_event.y1>560))return;// flag=0;
  
            	if ((ts_event.x1>910) &&(ts_event.y1>560))
              	{ 
				  	Foreground_color_65k(Black);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width,LCD_Height);
					Start_Square_Fill();

				 	Foreground_color_65k(Red);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width-1,LCD_Height-1);
					Start_Square();
					Foreground_color_65k(White);
					Background_color_65k(Black);

					Goto_Text_XY(40,200);
					Show_String("Capacitive touch screen test");
					Goto_Text_XY(LCD_Width-61,LCD_Height-25);
					Show_String("Clear");   
					Goto_Text_XY(5,LCD_Height-25);
					Show_String("Exit");
              	} 



					inttostr(ts_event.x1,ss);	

					Foreground_color_65k(White);
					Background_color_65k(Black);

					Goto_Text_XY(100,60);
					Show_String("X = ");	

					Text_Mode();
					LCD_CmdWrite(0x04);							
				  	LCD_DataWrite(ss[0]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[1]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[2]);
					//Delay1ms(1);
 				  	LCD_DataWrite(ss[3]);	 

					inttostr(ts_event.y1,ss);
					Goto_Text_XY(100,140);   //Set the display position
				  	LCD_CmdWrite(0x02);
					Show_String("Y = ");	
					Text_Mode();
					LCD_CmdWrite(0x04);	
				  	LCD_DataWrite(ss[0]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[1]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[2]);
					//Delay1ms(1);
 				  	LCD_DataWrite(ss[3]);


					if(ts_event.touch_point == 1)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);}

					if(ts_event.touch_point == 2)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);}
													 	
					if(ts_event.touch_point == 3)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);
													 Draw_Circle_Fill(Blue,ts_event.x3,ts_event.y3,2);}

					if(ts_event.touch_point == 4)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);
													 Draw_Circle_Fill(Blue,ts_event.x3,ts_event.y3,2);
													 Draw_Circle_Fill(Cyan,ts_event.x4,ts_event.y4,2);}	

					if(ts_event.touch_point == 5)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);
													 Draw_Circle_Fill(Blue,ts_event.x3,ts_event.y3,2);
													 Draw_Circle_Fill(Cyan,ts_event.x4,ts_event.y4,2);
													 Draw_Circle_Fill(Magenta,ts_event.x5,ts_event.y5,2);}

                     
				}while(INT==0);
				EX0=1;
			}



    }

	 IT0=0;        //Falling edge trigger  
	 EA=0;

}



#endif






#if RTP		  // Resistive touch screen

unsigned int x[1]=0; 		//Current coordinates
unsigned int y[1]=0;								
unsigned char touchtype=0;				
//The default is touchtype=0
unsigned char CMD_RDX=0XD0;
unsigned char CMD_RDY=0X90;

	 			    					   
// SPI write data
// Write data to the touchscreen IC 1byte
// num: data to be written
void TP_Write_Byte(unsigned char num)    
{  
	unsigned char count=0;   
	for(count=0;count<8;count++)  
	{ 	  
		if(num&0x80)TDIN=1;  
		else TDIN=0;   
		num<<=1;    
		TCLK=0; 
		_nop_();_nop_();_nop_();_nop_();
		TCLK=1;		//Rising Edge 	        
	}		 			    
} 		 
// SPI read data
// Read adc value from the touch screen IC
// CMD: Directive
// Returns: read data	   
unsigned int TP_Read_AD(unsigned char CMD)	  
{ 	 
	unsigned char count=0; 	  
	unsigned int Num=0; 
	TCLK=0;		//Pulling low the clock	 
	TDIN=0; 	//Pulling low the data line
	TCS=0; 		//Select the touchscreen IC
	_nop_();
	TP_Write_Byte(CMD);//Send command word

	_nop_();_nop_();_nop_();_nop_();
	TCLK=1; 
	_nop_();_nop_();_nop_();_nop_();     	      	   
	TCLK=0;		//To a clock, clear BUSY
	_nop_();_nop_();_nop_();_nop_();
     	     	    
	for(count=0;count<12;count++)//only the high 12
	{ 				  
		Num<<=1; 	 
		TCLK=1;		    	    
		_nop_();_nop_();_nop_();_nop_();  
 		TCLK=0;
 		if(DOUT)Num++; 		 
	}  	
	TCS=1;		 
	return(Num);   
}
// Reads a coordinate value (x or y)
// Sequential read READ_TIMES secondary data, these data in ascending order,
// Then remove the minimum and maximum number LOST_VAL, averaging
// xy: Directive (CMD_RDX / CMD_RDY)
// Returns: read data
#define READ_TIMES 10 	//Reads TIMES
#define LOST_VAL 2	  	//Discard value
unsigned int TP_Read_XOY(unsigned char xy)
{	unsigned int i, j;
	unsigned int buf[READ_TIMES];
	unsigned int sum=0;
	unsigned int temp;
	for(i=0;i<READ_TIMES;i++)buf[i]=TP_Read_AD(xy);		 		    
	for(i=0;i<READ_TIMES-1; i++)//Sequence
	{
		for(j=i+1;j<READ_TIMES;j++)
		{
			if(buf[i]>buf[j])//Ascending
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}	  
	sum=0;
	for(i=LOST_VAL;i<READ_TIMES-LOST_VAL;i++)sum+=buf[i];
	temp=sum/(READ_TIMES-2*LOST_VAL);
	return temp;   
} 
// Read the x, y coordinates
// Minimum of not less than 100.
// x, y: read coordinates
// Return value: 0, failed; a successful.
unsigned char TP_Read_XY(unsigned int *x,unsigned int *y)
{
	unsigned int xtemp,ytemp;			 	 		  
	xtemp=TP_Read_XOY(CMD_RDX);
	ytemp=TP_Read_XOY(CMD_RDY);	  												   
	//if(xtemp<100||ytemp<100)return 0;//Reading failure
	*x=xtemp;
	*y=ytemp;
	return 1;//Reading success
}
// 2 consecutive reads touchscreen IC, and this deviation should not exceed twice
// ERR_RANGE, to meet the conditions, then that reading is correct, otherwise erroneous readings.
// This function can greatly improve the accuracy of
// x, y: read coordinates
// Return value: 0, failed; a successful.
#define ERR_RANGE 100 //error range
unsigned char TP_Read_XY2(unsigned int *x,unsigned int *y) 
{
	unsigned int x1,y1;
 	unsigned int x2,y2;
 	unsigned char flag;    
    flag=TP_Read_XY(&x1,&y1);   
    if(flag==0)return(0);
    flag=TP_Read_XY(&x2,&y2);	   
    if(flag==0)return(0);   
    if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))&&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))//Twice before and after sampling within + -100
	
    {
        *x=(x1+x2)/2;
        *y=(y1+y2)/2;
        return 1;
    }else return 0;	  
}  




void TPTEST(void)
{  uchar exit=0; uint LX,LY;
	unsigned char ss[6];	


	Main_Image_Start_Address(0);				
	Main_Image_Width(LCD_Width);							
	Main_Window_Start_XY(0,0);

	Canvas_Image_Start_address(0);//Layer 1
	Canvas_image_width(LCD_Width);//
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);

 	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width,LCD_Height);
	Start_Square_Fill();

 ///////////////////////////Square
	Foreground_color_65k(Red);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square();
	delay_ms(1);


	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,0,0);

	while(next)
	{Foreground_color_65k(White);
	Background_color_65k(Black);

	Goto_Text_XY(40,200);	
	Show_String("Resistive touch screen test");

	Goto_Text_XY(LCD_Width-88,LCD_Height-40);

	Show_String("Clear");   
	Goto_Text_XY(15,LCD_Height-40);
	Show_String("Exit");
					 
		if(PEN==0 )			//Touch screen is pressed

		{	
		 								 	 		  
				TP_Read_XY2(&x[0],&y[0]);
			 	LX=((x[0]-100)*10/38);
				LY=((y[0]-200)*10/63);

	   
			 	//LX=((x[0]-100)*10/48);
				//LY=((y[0]-200)*10/77);

				if ((LX<85) &&(LY>560))return;// flag=0;
  
            	if ((LX>910) &&(LY>560))
              	{ 
				  	Foreground_color_65k(Black);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width,LCD_Height);
					Start_Square_Fill();

				 	Foreground_color_65k(Red);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width-1,LCD_Height-1);
					Start_Square();
					Foreground_color_65k(White);
					Background_color_65k(Black);
					CGROM_Select_Internal_CGROM();

					Goto_Text_XY(40,200);
					Show_String("Resistive touch screen test");
					Goto_Text_XY(LCD_Width-88,LCD_Height-40);

					Show_String("Clear");   
					Goto_Text_XY(15,LCD_Height-40);
					Show_String("Exit");
              	} 
		 	
			
				Draw_Circle_Fill(Red,LX,LY,2);

				ss[0]=LX/10000+48;
				ss[1]=(LX/1000)-((LX/10000)*10)+48;
				ss[2]=(LX/100)-((LX/1000)*10)+48;
				ss[3]=(LX/10)-((LX/100)*10)+48;
				ss[4]=LX-((LX/10)*10)+48;
				ss[5]=0;
	
				Foreground_color_65k(White);
				Background_color_65k(Black);


			Goto_Text_XY(10,305);
			Show_String("X:");
 			Goto_Text_XY(35,305);
			Show_String(ss);
	




				ss[0]=LY/10000+48;
				ss[1]=(LY/1000)-((LY/10000)*10)+48;
				ss[2]=(LY/100)-((LY/1000)*10)+48;
				ss[3]=(LY/10)-((LY/100)*10)+48;
				ss[4]=LY-((LY/10)*10)+48;
				ss[5]=0;
	
				Foreground_color_65k(White);
				Background_color_65k(Black);

			Goto_Text_XY(130,305);
			Show_String("Y:");
 			Goto_Text_XY(165,305);
			Show_String(ss);





			
		}
		else delay_ms(10);	//NO Touch	    
	
	}



}



#endif






